
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef pilo_POSTER_LIB_H
#define pilo_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "piloType.h"
#include "piloError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[PILO_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} PILO_CNTRL_STR;

/* For consistency with other posters */
typedef PILO_CNTRL_STR PILO_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "piloPosterLibStruct.h"



/* Posters */
#define PILO_CNTRL_POSTER_NAME genomInstanceSuffixName("pilo", "Cntrl")
#define PILO_POSREF_POSTER_NAME genomInstanceSuffixName("pilo", "PosRef")
#define PILO_SPEEDREF_POSTER_NAME genomInstanceSuffixName("pilo", "SpeedRef")
#define PILO_BASICTRAJ_POSTER_NAME genomInstanceSuffixName("pilo", "BasicTraj")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS piloPosterInit ( void );
extern POSTER_ID piloCntrlPosterID ();
extern STATUS piloCntrlPosterRead ( PILO_CNTRL_STR *piloCntrlStrId );
extern STATUS piloCntrlPosterInit ( void );
extern STATUS piloCntrlInstancePosterRead(const char *name, PILO_CNTRL_STR *piloCntrlStrId);
extern STATUS piloPosRefPosterInit ( void );
extern POSTER_ID piloPosRefPosterID ( void );
extern STATUS piloPosRefPosterRead ( PILO_POSREF_POSTER_STR *x );
extern STATUS piloPosRefInstancePosterRead ( const char *, PILO_POSREF_POSTER_STR * );
extern STATUS piloPosRefPosRefPosterRead ( GENPOS_CART_REF *PosRef );
extern STATUS piloPosRefPosRefInstancePosterRead( const char *, GENPOS_CART_REF * );
extern STATUS piloSpeedRefPosterInit ( void );
extern POSTER_ID piloSpeedRefPosterID ( void );
extern STATUS piloSpeedRefPosterRead ( PILO_SPEEDREF_POSTER_STR *x );
extern STATUS piloSpeedRefInstancePosterRead ( const char *, PILO_SPEEDREF_POSTER_STR * );
extern STATUS piloSpeedRefSpeedRefPosterRead ( GENPOS_CART_SPEED *SpeedRef );
extern STATUS piloSpeedRefSpeedRefInstancePosterRead( const char *, GENPOS_CART_SPEED * );
extern STATUS piloBasicTrajPosterInit ( void );
extern POSTER_ID piloBasicTrajPosterID ( void );
extern STATUS piloBasicTrajPosterRead ( PILO_BASICTRAJ_POSTER_STR *x );
extern STATUS piloBasicTrajInstancePosterRead ( const char *, PILO_BASICTRAJ_POSTER_STR * );
extern STATUS piloBasicTrajTrajPosterRead ( PILO_TRAJECTORY *Traj );
extern STATUS piloBasicTrajTrajInstancePosterRead( const char *, PILO_TRAJECTORY * );
#ifdef __cplusplus
}
#endif
#endif

